"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactLifecyclesCompat = require("react-lifecycles-compat");

var _ReferComponents = _interopRequireDefault(require("./ReferComponents"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (typeof call === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var FixedComponents =
/*#__PURE__*/
function (_React$Component) {
  _inherits(FixedComponents, _React$Component);

  function FixedComponents(props) {
    var _this;

    _classCallCheck(this, FixedComponents);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FixedComponents).call(this, props));
    _this.onChange = _this.onChange.bind(_assertThisInitialized(_this));
    _this.state = {
      id: _this.props.id,
      record: {},
      record2: {},
      recordValue: {}
    };
    return _this;
  }

  _createClass(FixedComponents, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      // console.log(nextProps.id, this.state.id);
      if (nextProps.id != this.state.id) {
        this.setState({
          id: nextProps.id,
          record: {},
          record2: {},
          recordValue: {}
        });
      }
    }
  }, {
    key: "onChange",
    value: function onChange(type, value) {
      var _this2 = this;

      // console.log([type,value])
      this.setState(_defineProperty({}, type, value), function () {
        if (type === 'record') {
          _this2.setState({
            record2: {},
            recordValue: {}
          });
        }

        if (type === 'record2') {
          _this2.setState({
            recordValue: {}
          });
        }

        if (type === 'recordValue' && value.id) {
          _this2.props.onInsertValue(' getID("' + _this2.state.record.code + '","' + value.title + '","' + value.id + '") ');

          _this2.props.onDesc('getID');
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          ReferDataUrl = _this$props.ReferDataUrl,
          fixedData = _this$props.fixedData; // console.log(['fixedData',fixedData,this.state]);
      // console.log(['this.state',this.state,fixedData]);

      return _react["default"].createElement("div", {
        className: "yy-tab-content"
      }, _react["default"].createElement("form", {
        className: "form-horizontal"
      }, _react["default"].createElement("div", {
        className: "form-group"
      }, _react["default"].createElement("label", {
        className: "col-sm-2 control-label"
      }, this.props.item.showName1), _react["default"].createElement("div", {
        className: "col-sm-10"
      }, _react["default"].createElement(_ReferComponents["default"], {
        url: ReferDataUrl,
        fixedData: JSON.parse(JSON.stringify(fixedData)),
        value: this.state.record,
        defaultCode: this.props.item.defaultCode,
        placeholder: this.props.item.placeholder,
        notFoundContent: this.props.item.notFoundContent,
        onChange: this.onChange.bind(this, 'record')
      }))), _react["default"].createElement("div", {
        className: "form-group"
      }, _react["default"].createElement("label", {
        className: "col-sm-2 control-label"
      }, this.props.item.showName2), _react["default"].createElement("div", {
        className: "col-sm-10"
      }, this.state.record.code === 'accsubject' ? _react["default"].createElement("div", null, _react["default"].createElement(_ReferComponents["default"], {
        url: ReferDataUrl,
        isCode: true,
        fixedData: _extends({}, JSON.parse(JSON.stringify(fixedData)), {
          refCode: 'accsubjectchart',
          refType: 'table',
          fields: ['id', 'code', 'name'],
          orderby: 'code asc',
          displayFields: ['id', 'code', 'name']
        }),
        disabled: !this.state.record.code,
        value: this.state.record2,
        placeholder: this.props.item.placeholder,
        notFoundContent: this.props.item.notFoundContent,
        onChange: this.onChange.bind(this, 'record2')
      }), _react["default"].createElement(_ReferComponents["default"], {
        url: ReferDataUrl,
        isCode: true,
        fixedData: _extends({}, JSON.parse(JSON.stringify(fixedData)), {
          refCode: this.state.record.code,
          filterCondition: JSON.stringify({
            accsubjectchart: this.state.record2.id ? this.state.record2.id : ''
          }),
          refType: 'table',
          fields: ['id', 'code', 'name'],
          orderby: 'code asc',
          displayFields: ['id', 'code', 'name']
        }),
        disabled: !this.state.record2.code,
        value: this.state.recordValue,
        placeholder: this.props.item.placeholder,
        notFoundContent: this.props.item.notFoundContent,
        onChange: this.onChange.bind(this, 'recordValue')
      })) : _react["default"].createElement(_ReferComponents["default"], {
        url: ReferDataUrl,
        fixedData: _extends({}, JSON.parse(JSON.stringify(fixedData)), {
          refCode: this.state.record.code
        }),
        disabled: !this.state.record.code,
        value: this.state.recordValue,
        placeholder: this.props.item.placeholder,
        notFoundContent: this.props.item.notFoundContent,
        onChange: this.onChange.bind(this, 'recordValue')
      })))));
    }
  }]);

  return FixedComponents;
}(_react["default"].Component);

FixedComponents.propTypes = {
  item: _propTypes["default"].object,
  ReferDataUrl: _propTypes["default"].string,
  fixedData: _propTypes["default"].object
};
FixedComponents.defaultProps = {
  item: {},
  ReferDataUrl: '',
  fixedData: {}
};
(0, _reactLifecyclesCompat.polyfill)(FixedComponents);
var _default = FixedComponents;
exports["default"] = _default;